#ifndef API_STRINGMAP_H
#define API_STRINGMAP_H

#include <string.h>

#define NEO_API_NUM_KEYS 56 
#define NEO_API_CODE_LENGTH 8

#define NEO_API_LOCALE_MAX_LENGTH 32
#define NEO_API_LOCALE_DIR "/resource/locales/"

struct NeoAPIMessageCat
{
	const char * name;
	const char * code;
	const char * defaultMsg;
};

class API_StringMap
{
public:
	API_StringMap()
	{
	}

	const char * getKeyName(int i)
	{
		if (i < NEO_API_NUM_KEYS)
		{
			return key_names[i].name;
		}
		return NULL;
	}

	const char * getKeyCode(int i)
	{
		if (i < NEO_API_NUM_KEYS)
		{
			return key_names[i].code;
		}
		return NULL;
	}

	static NeoAPIMessageCat key_names[NEO_API_NUM_KEYS];

private:

};


enum string_key
{
	API_KEY_ONE = 0,
	
	API_PARAMETER_PROFILE_NULL,
	API_PARAM_TAGNAME_INVALID,
	API_START_TAG_NOT_FOUND_IN_XML,
	API_END_TAG_NOT_FOUND_IN_XML,		// 5
	API_FAIL_LOC_UNEXP_EXCP,
	API_PARAM_XML_INVALID,
	API_PARAM_PREALLOCSIZE_INVALID,
	API_PARAM_XML_NO_XML,
	API_HOSTNAME_DOES_NOT_NEED_HTTP_PREFIX,		// 10
	API_CANNOT_INIT_SOCKET,
	API_CANNOT_INIT_SOCKET_X_FAILED,
	API_UNABLE_SET_KEEP_ALIVE_ON_SOCKET,
	API_INVALID_SOURCE_FILE_SPEC,
	API_COULD_NOT_OPEN_SOURCE_FILE_SPEC,		// 15
	API_XML_FILE_NO_XML,
	API_COULD_NOT_OPEN_PREFIX_FILE_SPEC,
	API_SOCKET_ERROR_SENDING_HEADER_TO_SERVER,
	API_SOCKET_ERROR_SENDING_BM_TO_SERVER,
	API_SOCKET_ERROR_SENDING_SB_TO_SERVER,		// 20
	API_SOCKET_ERROR_SENDING_SU_TO_SERVER,
	API_ERROR_COMM_SERVER_X,
	API_ERROR_WRITING_PREFIX_FILE_TO_SOCKET,
	API_ERROR_WRITING_SOURCE_FILE_TO_SOCKET,
	API_MUST_BE_SOURCE_SPEC_WHEN_STORING,		// 25
	API_ERROR_COMM_SERVER_READING_HTTP_HEADER,
	API_ERROR_COMM_SERVER_DID_NOT_RECV_HTTP_HEADER,
	API_X_NOT_RETURNED_IN_HEADER,
	API_UNABLE_ALLOC_MEMORY_FOR_RESULT,
	API_ERROR_COMM_SERVER_READING_HTTP_CONTENT,		// 30
	API_CANNOT_CREATE_X_WITH_NULL_NEOCONN,
	API_CANNOT_CREATE_X_WITH_NULL_SID,
	API_PARAM_X_INVALID,
	API_COULD_NOT_LOC_ELEM_IN_XML,
	API_XML_NOT_WELL_FORMED,		// 35
	API_INVALID_LOGIN_RESPONSE,
	API_INVALID_SID,
	API_X_IS_NULL,
	API_X_IS_EMPTY,
	API_X_NEEDS_NON_NULL_POOL,		// 40
	API_ALREADY_LOGGED_IN,
	API_UNABLE_GET_CONN_CANNOT_PERFORM_REQ,
	API_X_NEEDS_VALID_NON_NULL_TAG,
	API_MAXCON_TOTALCON_MUST_BE_GT_1,
	API_MAXCON_MUST_BE_GT_TOTALCON,		// 45
	API_COULD_NOT_ADD_CONN_TO_POOL,
	API_POOL_CLOSED_NO_NEW_CONN_RELEASED,
	API_CANNOT_REMOVE_LT_1_CONN,
	API_CANNOT_REPLENISH_CLOSED_POOL,
	API_CANNOT_ADD_LT_1_CONN,		// 50
	API_CANNOT_INC_POOL_SIZE,
	API_CANNOT_SET_TIMEOUT_LT_1_SEC,
	API_POOL_CLOSED_NO_NEW_CONN_ADDED,
	API_CANNOT_INC_CONN_PAST_MAX,
	API_X_NOT_RETURNED_IN_HTTP_HEADER,		// 55


	
	
	API_KEY_LAST
};

#endif


