//  Copyright 2001-2002, NeoCore Inc.
//  All Rights Reserved

#ifndef ISOLATIONLEVEL_H
#define ISOLATIONLEVEL_H
/** 
  * @memo <DL><DD>Enumeration of isolation levels.</DD></DL>
  * @doc <br/>Enumeration of isolation levels.<br/>
  *	READ_UNCOMMITTED - allow dirty reads. No read locks are used. 
  * READ_COMMITTED - Read and write locks are used. Read locks are released after each command. 
  *  REPEATABLE_READ - Read and write locks are used. Read locks are not released until end of transaction. 
  *
  *
  */


enum IsolationLevel
{
    READ_UNCOMMITTED=0,
    READ_COMMITTED,
    REPEATABLE_READ,
    SERIALIZABLE
} ;

#endif